diff -urN sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
+++ source/scripts/jmgBearHunter.cpp	2020-09-26 08:59:57.398127800 +1000
@@ -1135,31 +1137,21 @@
 			if (gameTime == 240)
 			{
 				if (NewObjectiveSystemControl.Get_Objective_Status(21) == NewObjectiveSystem::Pending && NewObjectiveSystemControl.Get_Mission_Text_Id(21) != 12790)
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The gate will be back on-line in the next 4 minutes, if you can't get the signal sent within the next minute don't bother!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH35.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH35.mp3","Bear Rug Co: The gate will be back on-line in the next 4 minutes, if you can't get the signal sent within the next minute don't bother!");
 				gameState = DefendPrez;
 			}
 			if (gameTime == 180)
 			{
 				if (NewObjectiveSystemControl.Get_Objective_Status(21) == NewObjectiveSystem::Pending && NewObjectiveSystemControl.Get_Mission_Text_Id(21) != 12790)
 				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Forget about the communications tower, there isn't enough time anymore; focus all resources on defending the president!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH36.mp3");
+					BearHunterVoiceSystem::PlayVoice("BH36.mp3","Bear Rug Co: Forget about the communications tower, there isn't enough time anymore; focus all resources on defending the president!");
 					NewObjectiveSystemControl.Remove_Objective(21);
 				}
 			}
 			if (gameTime == 150)
-			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Oh god, is that a moose? What are they doing out here... Never mind, defend the President of Corperate America!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH37.mp3");
-			}
+				BearHunterVoiceSystem::PlayVoice("BH37.mp3","Bear Rug Co: Oh god, is that a moose? What are they doing out here... Never mind, defend the President of Corperate America!");
 			if (gameTime == 60)
-			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: And... Here comes the cougars... looks like everything is going straight for the President of Corperate America!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH38.mp3");
-			}
+				BearHunterVoiceSystem::PlayVoice("BH38.mp3","Bear Rug Co: And... Here comes the cougars... looks like everything is going straight for the President of Corperate America!");
 			if ((gameTime == 600 || gameTime == 300) || (!(gameTime % 60) && gameTime > 0 && gameTime < 300))
 			{
 				char timeMsg[220];
@@ -1180,8 +1172,7 @@
 			}
 			if (gameTime == 0)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Mainframe back on-line, gates are closing!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH39.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH39.mp3","Bear Rug Co: Mainframe back on-line, gates are closing!");
 				Commands->Static_Anim_Phys_Goto_Last_Frame(650185,"BH_GATE_1.BH_GATE_1");
 				Commands->Static_Anim_Phys_Goto_Last_Frame(650186,"BH_GATE_1.BH_GATE_1");
 				Commands->Static_Anim_Phys_Goto_Last_Frame(650187,"BH_GATE_1.BH_GATE_1");
@@ -1200,83 +1191,24 @@
 			CreatePositionZ = 500-1000*(1-gameTime/1800.0f)+2;
 			GamePercent = JmgUtility::MathClamp(1-(gameTime-Get_Player_Count()*2.5f)/1210.0f,0.0f,10.0f);//Was 7.5
 			int normalBears = (int)(!bearTransition ? maxTotalEnemies : (bearTransition == 100 ? 0 : maxTotalEnemies*(1-bearTransition/100.0f)));
-			if ((int)(normalBears * 0.25f) > JMG_Bear_Hunter_AI_Avoid_Enemies::wildAnimalCount)
-			{
-				bool deer = Commands->Get_Random(0.0f,1.0f) < 0.5f;
-				Vector3 pos = BearHunterGameControlSystem.LookupNearestPosition(Vector2(Commands->Get_Random(-500.0f,500.0f),Commands->Get_Random(-350.0f,500.0f)));
-				GameObject *ai = deer ? Commands->Create_Object("Normal_Buck_Twiddler",pos) : Commands->Create_Object("Normal_Squirrel_Twiddler",pos);
-				Commands->Set_Facing(ai,Commands->Get_Random(-180,180));
-				MoveablePhysClass *mphys = ai->As_PhysicalGameObj() ? ai->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
-				if (mphys)
-					mphys->Find_Teleport_Location(pos,2.0f,&pos);
-				Commands->Set_Position(ai,pos);
-				if (deer)
-				{
-					Attach_Script_Once(ai,"JMG_Utility_AI_Skittish_Herd_Animal","0,4,511,25.0,30.0,50.0,200.0,6.0,24.0,10.0,25.0,0.1,0.125");
-					Commands->Set_Model(ai,Commands->Get_Random(0.0f,1.0f) < 0.25f ? "BUCK_" : "DOE_");
-				}
-				else
-					Attach_Script_Once(ai,"JMG_Bear_Hunter_AI_Avoid_Enemies","");
-				Attach_Script_Once(ai,"JMG_Security_Camera_Behavior_Ignore","");
-			}
+			CreateNormalAnimals(normalBears);
 			if (!normalBears && JMG_Bear_Hunter_AI_Avoid_Enemies::wildAnimalCount)
-			{
 				for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
 				{
 					SmartGameObj* o = current->Data();
-					if (o && Is_Script_Attached(o,"JMG_Bear_Hunter_AI_Avoid_Enemies"))
-						Commands->Apply_Damage(o,1000.0f,"None",0);
-				}
-			}
-			for (int x = bearObjectListControl.objectCount;x < normalBears;x++)
-			{
-				Vector3 pos = BearHunterGameControlSystem.LookupNearestPosition(Vector2(Commands->Get_Random(-500.0f,500.0f),Commands->Get_Random(-350.0f,500.0f)));
-				bool isBlackBear = Commands->Get_Random(0.0f,1.0f) < 0.1 ? true : false;
-				GameObject *ai = isBlackBear ? Commands->Create_Object("Bear_Black_Twiddler",pos) : Commands->Create_Object("Normal_Bear_Twiddler",pos);
-				Commands->Set_Facing(ai,Commands->Get_Random(-180,180));
-				MoveablePhysClass *mphys = ai->As_PhysicalGameObj() ? ai->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
-				if (mphys)
-					mphys->Find_Teleport_Location(pos,2.0f,&pos);
-				pos.Z += 0.1f;
-				Commands->Set_Position(ai,pos);
-				Commands->Set_Loiters_Allowed(ai,true);
-				ai->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
-				bearObjectListControl += ai;
-				Attach_Script_Once(ai,"JMG_Rp2_Hostile_Mutant_AI","");
-				Attach_Script_Once(ai,"JMG_Bear_Hunter_Bear_Tracker","");
-				Attach_Script_Once(ai,"JMG_Bear_Hunter_Animal_Control","");
-				Attach_Script_Once(ai,"JMG_Bear_Hunter_Player_Count_Scaled_Object_Health","");
-			}
-			if (bearObjectListControl.objectCount > normalBears)
-				bearObjectListControl.DestroyLeastSignificant();
-			if (JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue)
-			{
-				GameObject *statuePlayer = Get_GameObj(JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue);
-				if (statuePlayer)
-				{
-					int deerCount = JmgUtility::MathClampInt(3+(int)(0.33f*Get_Player_Count()),3,25);
-					for (int x = 0;x < deerCount;x++)
+					if (o && (Is_Script_Attached(o,"JMG_Bear_Hunter_AI_Avoid_Enemies") || Is_Script_Attached(o,"JMG_Utility_AI_Skittish_Herd_Animal")))
 					{
-						if (Commands->Find_Object(JMG_Bear_Hunter_Golden_Deer_Statue::tinyDeerIds[x]))
+						JMG_Bear_Hunter_AI_Avoid_Enemies *script = (JMG_Bear_Hunter_AI_Avoid_Enemies*)Find_Script_On_Object(o,"JMG_Bear_Hunter_AI_Avoid_Enemies");
+						if (script && script->mouse)
 							continue;
-						Vector3 playerPos = Commands->Get_Position(statuePlayer);
-						if (BearHunterGameControlSystem.getRandomPosition(&playerPos,500.0f,2500.0f))
-						{
-							GameObject *tinyDeer = Commands->Create_Object("Tiny_Deer_Twiddler",playerPos);
-							MoveablePhysClass *mphys = tinyDeer->As_PhysicalGameObj() ? tinyDeer->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
-							if (mphys && !mphys->Can_Teleport(Matrix3D(playerPos)))
-							{
-								mphys->Find_Teleport_Location(playerPos,1.5f,&playerPos);
-								Commands->Set_Position(tinyDeer,playerPos);
-							}
-							tinyDeer->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
-							Commands->Attach_Script(tinyDeer,"JMG_Utility_AI_Goto_Player","-1.0,1.0,1.0,0.0,0,1.0,-1.0,0.0,0,1.0,-1,1.0,1,0,0.0");
-							Commands->Attach_Script(tinyDeer,"JMG_Bear_Hunter_Kill_Score_Tracker","");
-							JMG_Bear_Hunter_Golden_Deer_Statue::tinyDeerIds[x] = Commands->Get_ID(tinyDeer);
-						}
+						Commands->Apply_Damage(o,1000.0f,"None",0);
 					}
 				}
-			}
+			CreateMouse();
+			CreateBears(normalBears);
+			if (bearObjectListControl.objectCount > normalBears)
+				bearObjectListControl.DestroyLeastSignificant();
+			SpawnAngryTinyDeer();
 			if (gameTime == 1200)
 			{
 				GameObject *Meteor = Commands->Create_Object("Meteorite_Animation",BearHunterGameControlSystem.LookupNearestPosition(Vector2(0.0f,200.0f)));
@@ -1285,13 +1217,13 @@
 				Commands->Send_Custom_Event(Meteor,obj,987988,0,1.0f);
 			}
 		}
+		TriggerCowObjective();
 		Commands->Start_Timer(obj,this,1.0f,3);
 	}
 	if (number == 4)
 	{
 		gameState = SecureBase;
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Kill all remaining mutants inside the walls!");
-		JmgUtility::Create_2D_Wave_Sound_Dialog("BH40.mp3");
+		BearHunterVoiceSystem::PlayVoice("BH40.mp3","Bear Rug Co: Kill all remaining mutants inside the walls!");
 		objective = 12699;
 		JmgUtility::SetHUDHelpText(objective,Vector3(0,1,0));
 		NewObjectiveSystemControl.Set_Objective_Status(6,NewObjectiveSystem::Accomplished);
@@ -1354,15 +1286,9 @@
 				if (!JMG_Bear_Hunter_Game_Control::hasBeenInjured)
 					spawnKarma += 2;
 				if (!JMG_Bear_Hunter_Game_Control::hasBeenInjured)
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: I cannot believe it; the president did not even get hurt once, if I did not know better, I would think you were cheating!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH41.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH41.mp3","Bear Rug Co: I cannot believe it; the president did not even get hurt once, if I did not know better, I would think you were cheating!");
 				else
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Great work guys, I think thats all of them!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH42.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH42.mp3","Bear Rug Co: Great work guys, I think thats all of them!");
 			}
 			if (winWait == 13)
 			{
@@ -1383,8 +1309,7 @@
 					turretState = 2;
 				if (turretState)
 				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Just in time too, looks like the turret control computer was about to burn up. Shutting it down now...");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH43.mp3");
+					BearHunterVoiceSystem::PlayVoice("BH43.mp3","Bear Rug Co: Just in time too, looks like the turret control computer was about to burn up. Shutting it down now...");
 				}
 				if (0.7f < (1.0f*NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Secondary,NewObjectiveSystem::Accomplished)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Tertiary,NewObjectiveSystem::Accomplished)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Quaternary,NewObjectiveSystem::Accomplished))/(1.0f*NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Secondary)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Tertiary)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Quaternary)))
 					spawnKarma++;
@@ -1449,20 +1374,11 @@
 			if (winWait == 23)
 			{
 				if (spawnKarma <= 1)
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Haha, its a good thing this isn't a video game, otherwise I'd have expected some sort of super mutant boss.");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH44.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH44.mp3","Bear Rug Co: Haha, its a good thing this isn't a video game, otherwise I'd have expected some sort of super mutant boss.");
 				else if (spawnKarma <= 3)
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Haha, its a good thing this isn't a video game, otherwise I'd have expected some sort of super mutant boss, with maybe some support bosses because you did so well.");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH45.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH45.mp3","Bear Rug Co: Haha, its a good thing this isn't a video game, otherwise I'd have expected some sort of super mutant boss, with maybe some support bosses because you did so well.");
 				else
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: However, it is a good thing you people are not cheaters, otherwise karma would try to find a way to balance the odds.");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH46.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH46.mp3","Bear Rug Co: However, it is a good thing you people are not cheaters, otherwise karma would try to find a way to balance the odds.");
 				Commands->Set_Lightning(1.0f,0.0f,0.25f,0.0f,1.0f,20.0f);
 				sprintf(currentSong,"304557_Goliath.mp3");
 			}
@@ -1470,8 +1386,7 @@
 				Commands->Fade_Background_Music("304557_Goliath.mp3",10000,10000);
 			if (winWait == 43)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Well, we should have seen this coming, hurry guys, kill it and we'll call it a day!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH47.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH47.mp3","Bear Rug Co: Well, we should have seen this coming, hurry guys, kill it and we'll call it a day!");
 				Commands->Create_Object("Mutant_Rabbit_Boss",Vector3(0.0f,0.0f,0.0f));
 				if (spawnKarma >= 2)
 					for (int x = 0;x < spawnKarma;x++)
@@ -1524,8 +1439,7 @@
 			Vector3 switchPos = Commands->Get_Position(switchObj);
 			if (CheckIfPlayerInRange(switchPos,22500))
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: By the way, there is an active security system in the complex, you might want to deactivate it before you take the truck.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH48.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH48.mp3","Bear Rug Co: By the way, there is an active security system in the complex, you might want to deactivate it before you take the truck.");
 				NewObjectiveSystemControl.Add_Objective(14,NewObjectiveSystem::Quaternary,NewObjectiveSystem::Pending,12740,"",12740);
 				return;
 			}
@@ -1591,18 +1505,22 @@
 					Commands->Action_Goto(ai,params);
 					Commands->Attach_Script(ai,"JMG_Bear_Hunter_Engineer_AI","Weapon_RepairGun_Player,Weapon_Pistol_Player,0.5 0.75 0.9");
 					entineersReturned++;
-					float money = 125;
+					float money = 75;
 					if (entineersReturned == 5)
-						money = 500;
+						money = 250;
 					JMG_Bear_Hunter_Game_Control::ObjectiveCompleteReward(money);
 					GameObject *guide = Get_GameObj(JMG_Bear_Hunter_Engineer_Follow_Player_When_Near::followPlayerId[x]);
 					if (guide)
 					{
-						Commands->Give_Points(guide,250.0f,false);
-						BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(guide));
-						node->BonusObjectivesCompleted++;
-						node->totalObjectivesCompleted++;
-						node->ObjectiveEngineersSaved++;
+						int playerId = JmgUtility::JMG_Get_Player_ID(guide);
+						if (playerId)
+						{
+							Set_Score(playerId,Get_Score(playerId)+250.0f);
+							BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(playerId);
+							node->BonusObjectivesCompleted++;
+							node->totalObjectivesCompleted++;
+							node->ObjectiveEngineersSaved++;
+						}
 					}
 					missionUpdate = true;
 				}
@@ -1615,8 +1533,7 @@
 			engineerScanTime = 10;
 			if (entineersReturned == 5)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thats all of them, great work guys!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH49.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH49.mp3","Bear Rug Co: Thats all of them, great work guys!");
 				NewObjectiveSystemControl.Set_Objective_Status(15,NewObjectiveSystem::Accomplished);
 			}
 			else
@@ -1626,15 +1543,13 @@
 				if (totalEngineers == 5)
 				{
 					sprintf(successMsg,"Bear Rug Co: Looks like we saved %d of the 5 engineers, it's good to see some of them back.",entineersReturned);
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH50.mp3");
-					JmgUtility::MessageAllPlayers(127,127,255,successMsg);
+					BearHunterVoiceSystem::PlayVoice("BH50.mp3",successMsg);
 					NewObjectiveSystemControl.Remove_Objective(15);
 				}
 				else
 				{
 					sprintf(successMsg,"Bear Rug Co: Good work bringing another engineer home, %d more to go.",5-totalEngineers);
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH51.mp3");
-					JmgUtility::MessageAllPlayers(127,127,255,successMsg);
+					BearHunterVoiceSystem::PlayVoice("BH51.mp3",successMsg);
 					unsigned int textId = (totalEngineers == 1) ? 12743 : (totalEngineers == 2) ? 12744 : (totalEngineers == 3) ? 12745 : 12746;
 					NewObjectiveSystemControl.Set_Objective_Mission(15,textId,textId);
 				}
@@ -1647,16 +1562,11 @@
 			lastUpdateEngineersDead = JMG_Bear_Hunter_Engineer_AI::engineersDead;
 			switch (JMG_Bear_Hunter_Engineer_AI::engineersDead)
 			{
-			case 1:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like we lost an engineer.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH52.mp3");break;
-			case 2:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Another engineer has died.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH53.mp3");break;
-			case 3:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've lost another engineer! Be more careful, these people have families!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH54.mp3");break;
-			case 4:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Four engineers dead, maybe you should just let the last one hide.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH55.mp3");break;
-			case 5:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've lost all the engineers, I understand you guys didn't have training in fighting killer animals, but we still expected better.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH56.mp3");break;
+			case 1:BearHunterVoiceSystem::PlayVoice("BH52.mp3","Bear Rug Co: Looks like we lost an engineer.");break;
+			case 2:BearHunterVoiceSystem::PlayVoice("BH53.mp3","Bear Rug Co: Another engineer has died.");break;
+			case 3:BearHunterVoiceSystem::PlayVoice("BH54.mp3","Bear Rug Co: We've lost another engineer! Be more careful, these people have families!");break;
+			case 4:BearHunterVoiceSystem::PlayVoice("BH55.mp3","Bear Rug Co: Four engineers dead, maybe you should just let the last one hide.");break;
+			case 5:BearHunterVoiceSystem::PlayVoice("BH56.mp3","Bear Rug Co: We've lost all the engineers, I understand you guys didn't have training in fighting killer animals, but we still expected better.");break;
 			}
 			int totalEngineers = entineersReturned+JMG_Bear_Hunter_Engineer_AI::engineersDead;
 			if (JMG_Bear_Hunter_Engineer_AI::engineersDead == 5)
@@ -1665,8 +1575,7 @@
 			{
 				char engineerMsg[220];
 				sprintf(engineerMsg,"Bear Rug Co: Looks like we saved %d of the 5 engineers, it's good to see some of them back.",entineersReturned);
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH50.mp3");
-				JmgUtility::MessageAllPlayers(127,127,255,engineerMsg);
+				BearHunterVoiceSystem::PlayVoice("BH50.mp3",engineerMsg);
 				NewObjectiveSystemControl.Remove_Objective(15);
 			}
 			else
@@ -1686,8 +1595,7 @@
 				continue;
 			if (JmgUtility::SimpleFlatDistance(Vector3(50.0f,-685.0f,0),Commands->Get_Position(player)) > 2500.0f)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: While you are hunting for bears keep an eye out for weapons containers, 6 of them have been misplaced and we will let you use the weapons if you bring them back to base.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH57.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH57.mp3","Bear Rug Co: While you are hunting for bears keep an eye out for weapons containers, 6 of them have been misplaced and we will let you use the weapons if you bring them back to base.");
 				IncreaseBonusObjectiveCount(18);
 				NewObjectiveSystemControl.Add_Objective(18,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12772,"",12772,bonusObjectiveCount);
 				return;
@@ -1697,6 +1605,8 @@
 	}
 	if (number == 12)
 	{
+		for (int x = 0;x < 5;x++)
+			CreateMouse();
 		GameObject *giantDeer = Commands->Create_Object("Giant_Deer",Vector3(424.87f,133.22f,0.22f));
 		Commands->Attach_Script(giantDeer,"JMG_Bear_Hunter_Giant_Deer_Boss","");
 		blackBearId = Commands->Get_ID(giantDeer);
@@ -1883,7 +1793,6 @@
 		for (int x = 0;x < 3;x++)
 			Commands->Create_Sound("SFX.Dynamite_Explosion2",Commands->Get_Position(sender),sender);
 		Commands->Create_Explosion("Explosion_Meteor",Commands->Get_Position(sender),sender);
-		int pumpJackIds[7] = {601041,601038,601044,601040,601045,601039,601043};
 		for (int x = 0;x < 7;x++)
 		{
 			GameObject *pumpJack = Commands->Find_Object(pumpJackIds[x]);
@@ -1917,9 +1826,6 @@
 			}
 		}
 		Commands->Destroy_Object(sender);
-		GameObject *deerStatue = Commands->Find_Object(JMG_Bear_Hunter_Golden_Deer_Statue::statueId);
-		if (deerStatue)
-			Commands->Destroy_Object(deerStatue);
 		if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Failed && NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Accomplished)
 			for (int x = 0;x < 8;x++)
 			{
@@ -1927,6 +1833,9 @@
 				if (mlion)
 					Commands->Destroy_Object(mlion);
 			}
+		GameObject *deerStatue = Commands->Find_Object(JMG_Bear_Hunter_Golden_Deer_Statue::statueId);
+		if (deerStatue)
+			Commands->Destroy_Object(deerStatue);
 		GameObject *deerPlayer = Get_GameObj(JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue);
 		if (deerPlayer)
 		{
@@ -1938,8 +1847,7 @@
 		}
 		if (NewObjectiveSystemControl.Get_Objective_Status(24) != NewObjectiveSystem::NotDefined && NewObjectiveSystemControl.Get_Objective_Status(24) != NewObjectiveSystem::Accomplished)
 		{
-			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The statue has vanished, forget about it.");
-			JmgUtility::Create_2D_Wave_Sound_Dialog("BH58.mp3");
+			BearHunterVoiceSystem::PlayVoice("BH58.mp3","Bear Rug Co: The statue has vanished, forget about it.");
 			NewObjectiveSystemControl.Set_Objective_Status(24,NewObjectiveSystem::Failed);
 		}
 	}
@@ -1949,8 +1857,7 @@
 		{
 			if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::NotDefined)
 				return;
-			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Oh look, a pride of cougars... The boys bet that you guys can't pet them all, $50.00 per cat if you can!");
-			JmgUtility::Create_2D_Wave_Sound_Dialog("BH59.mp3");
+			BearHunterVoiceSystem::PlayVoice("BH59.mp3","Bear Rug Co: Oh look, a pride of cougars... The boys bet that you guys can't pet them all, $50.00 per cat if you can!");
 			IncreaseBonusObjectiveCount(25);
 			NewObjectiveSystemControl.Add_Objective(25,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12832,"",12832,bonusObjectiveCount);
 		}
@@ -1968,7 +1875,8 @@
 			if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Pending)
 			{
 				bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(sender))->FailedPettingCougars++;
-				NewObjectiveSystemControl.Add_Objective(25,NewObjectiveSystem::Unknown,NewObjectiveSystem::Hidden,12832,"",12832,obj);
+				if (NewObjectiveSystemControl.Get_Objective_Status(25) == NewObjectiveSystem::NotDefined)
+					NewObjectiveSystemControl.Add_Objective(25,NewObjectiveSystem::Unknown,NewObjectiveSystem::Hidden,12832,"",12832);
 				NewObjectiveSystemControl.Set_Objective_Status(25,NewObjectiveSystem::Failed);
 				return;
 			}
@@ -1977,8 +1885,7 @@
 				bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(sender))->FailedPettingCougars++;
 				NewObjectiveSystemControl.Set_Objective_Status(25,NewObjectiveSystem::Failed);
 			}
-			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like one died, now the bet is off!");
-			JmgUtility::Create_2D_Wave_Sound_Dialog("BH60.mp3");
+			BearHunterVoiceSystem::PlayVoice("BH60.mp3","Bear Rug Co: Looks like one died, now the bet is off!");
 		}
 	}
 	if (message == 2684270)
@@ -2004,8 +1911,7 @@
 				Commands->Set_Player_Type(mlion,1);
 				Commands->Attach_Script(mlion,"JMG_Bear_Hunter_Friendly_Cougar","1.0,10.0,1.0,1.5,3.0,0.0,3,6,5.0");
 			}
-			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: I don't believe it! Those cougars look like they're your best friends now!");
-			JmgUtility::Create_2D_Wave_Sound_Dialog("BH61.mp3");
+			BearHunterVoiceSystem::PlayVoice("BH61.mp3","Bear Rug Co: I don't believe it! Those cougars look like they're your best friends now!");
 			NewObjectiveSystemControl.Set_Objective_Status(25,NewObjectiveSystem::Accomplished);
 			for (int x = 1;x < 128;x++)
 			{
@@ -2017,12 +1923,35 @@
 				{
 					Commands->Give_Points(player,50.0f*node->tmpPettedCougars,false);
 					node->BonusObjectivesCompleted++;
+					node->totalObjectivesCompleted++;
 				}
 			}
 		}
 		else
 			NewObjectiveSystemControl.Set_Objective_Mission(25,wildMountainLionsPet+12832,wildMountainLionsPet+12832);
 	}
+	if (message == 4588)
+	{
+		GameObject *cow = Commands->Find_Object(cowId);
+		if (!cow)
+			return;
+		char params[256];
+		sprintf(params,"%d,0.33,-1.0,1,1,1.0,0.0,1,0,0",cowWanderId);
+		Commands->Attach_Script(cow,"JMG_Bear_Hunter_AI_Guardian_Generic",params);
+	}
+	if (message == 4590)
+	{
+		NewObjectiveSystemControl.Set_Objective_Status(27,NewObjectiveSystem::Accomplished);
+		BearHunterVoiceSystem::PlayVoice("BH98.mp3","Bear Rug Co: Thanks for bringing the cow back, enjoy some fresh milk!");
+		for (int x = 1;x < 128;x++)
+		{
+			GameObject *player = Get_GameObj(x);
+			if (!player)
+				continue;
+			Grant_Weapon(player,"Weapon_Milk_Whole",true,500,true);
+			Grant_Weapon(player,"Weapon_Milk_2Percent",true,500,true);
+		}
+	}
 }
 void JMG_Bear_Hunter_Game_Control::Destroyed(GameObject *obj)
 {
